<template>
  <div>
    <Modal v-model="showModal" width="1200" class="modal-footer-none">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <!--内容-->
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="formId" :label-width="80" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item label="样品名称:" class="search-item">
                <Input v-model="formObj.name" @on-enter="_formSearch" placeholder="请输入样品名称" clearable/>
              </Form-item>
              <Form-item label="样品编号:" class="search-item">
                <Input v-model="formObj.code" @on-enter="_formSearch" placeholder="请输入样品编号" clearable/>
              </Form-item>
              <Form-item class="search-btn" style="margin-left: -10px">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                      class="contHide"></btn-list>
          </Col>
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :get-page="getPage"
                        :icon-msg="iconMsg" @on-result-change="_tableResultChange" select-data>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id)">{{scope.row[item.key]}}</a></div>
                  <div v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </div>
                  <div v-else-if="item.status">{{scope.row[item.key].display}}</div>
                  <div v-else-if="item.key==='jobOut'">
                     {{scope.row[item.key]===1?'是':'否'}}
                  </div>
                  <div v-else-if="item.key==='type'">
                    <Select v-model="scope.row.type">
                      <Option v-for="(item,index) in options" :key="item.name" :value="index">
                        {{ item.name }}
                      </Option>
                    </Select>
                  </div>
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult"></modal-footer>
      </div>
    </Modal>
    <assignPerson ref="userModal" @on-result-change="_userData" is-change></assignPerson>

    <MeterItemManage ref="itemManageModal"  @on-result-change="_page"></MeterItemManage>
    <MeterSendHisTaskOperation ref="operationModal" @on-result-change="_page"></MeterSendHisTaskOperation>
    <importModal ref="importModal"  @on-result-change="_importBack"></importModal>
  </div>
</template>
<script>
import { meterSample } from '../../../api'
import assignPerson from '../../../components/user-info-single/assignPerson'
import MeterItemManage from '../MeterItemManage'
import importModal from '../../contract-tab/ContractTab'
import MeterSendHisTaskOperation from '../../../components/operation/Operation'
export default {
  components: {
    assignPerson,
    MeterItemManage,
    importModal,
    MeterSendHisTaskOperation
    // FoodSampleGovernDetail,
    // CopyModal,
    // FoodSampleGovernLYEdits
  },
  data() {
    return {
      currentComponent: '',
      // btn: [
      //   {type: 'success', id: '', name: '添加', componentName: 'FoodSampleGovernEdit'},
      //   {id: 'food-gov-sample-batch-add', name: '批量添加', componentName: 'FoodSampleGovernBatchAdd'},
      //   {id: '', name: '导入样品', componentName: 'FoodImportSample'},
      //   {id: '', name: '导入检测项目', componentName: 'RelItem'},
      //   {id: '', name: '导入检测项目包', componentName: 'RelItemPackage'},
      //   {id: '', name: '复制历史样品检测项目', componentName: 'CopyHisItem'},
      //   {id: '', name: '删除'},
      // ],
      iconMsg: [
        {
          type: 'ios-beaker',
          id: 'meter-task-alloca-his-item-manage',
          name: '检测项目管理'
        },
        {
          type: 'ios-clock',
          id: 'meter-task-alloca-his-record',
          name: '操作日志'
        }
      ],
      footerList: [
        { id: '', name: '关闭', type: '' },
        { id: '', name: '确定', type: 'primary' }
      ],
      btn: [
        {
          type: 'success',
          id: 'meter-task-alloca-his-allocation-btn',
          name: '任务重新分配'
        },
        {
          type: 'success',
          id: 'meter-task-alloca-his-import-item-btn',
          name: '导入检测项目'
        }
      ],
      searchOpen: false,
      options: [
        {
          name: '检定'
        },
        {
          name: '校准'
        },
        {
          name: '外观检查'
        }
      ],
      formId: 'meterReviewSampleManageFormId',
      showModal: false,
      modalTitle: '管理样品',
      selectIds: [],
      selectData: [],
      getPage: {},
      pageColumns: [
        { title: '样品编号', key: 'code', width: 120 },
        { title: '样品名称', key: 'name', width: 140 },
        { title: '任务人', key: 'testUser', width: 130 },
        { title: '状态', key: 'progress', width: 120, status: true },
        { title: '检测项目', key: 'itemNames', width: 140 },
        { title: '型号规格', key: 'spec', width: 140 },
        { title: '出厂编号', key: 'factoryNumber', width: 140 },
        { title: '是否分包', key: 'jobOut', width: 110 },
        { title: '检测类型', key: 'type', width: 140 },
        { title: '数量', key: 'quantity', width: 140 }
      ],
      dateList: [],
      formObj: {
        entrustId: undefined,
        name: undefined,
        code: undefined,
        type: undefined
      }
    }
  },
  computed: {
    tableHeight: function() {
      return this.$tableHeight('tableModal')
    }
  },
  methods: {
    _footerResult(name) {
      switch (name) {
        case '关闭':
          this._cancel()
          break
        case '确定':
          this._cancel()
          break
      }
    },
    _cancel() {
      this.showModal = false
      this.$emit('on-result-change')
    },
    _dateChange(data) {
      this.formObj.ctimeBegin = data[0]
      this.formObj.ctimeEnd = data[1]
    },
    _importBack() {
      this.selectIds = []
      this._page()
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '任务重新分配':
            this._changePeople()
            break
          case '添加':
            this._editModal(false)
            break
          case '导入检测项目':
            this._importItem()
            break
          case '导入检测项目包':
            this._importItemPackage()
            break
          case '复制历史样品检测项目':
            this._copyHisItem()
            break
          case '删除':
            this._deleteSelected()
            break
        }
      })
    },
    _userData(data, msg) {
      if (msg === 'salesman') {
        this._distributeSample(data)
      }
    },

    _distributeSample: async function(data) {
      const userId = data.id
      const realname = data.realname
      const ids = this.selectIds
      const result = await meterSample.distributeAgain({
        ids: ids,
        userId: userId,
        user: realname
      })
      if (result) {
        this.$Message.success('分配成功!')
        await this._page()
      }
    },
    _changePeople() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择至少一项数据!')
        return false
      } else {
        this.$refs.userModal._open('salesman')
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            localStorage.setItem('type', data.type)
            if (data.type === 2) {
              this._editLY(data.id) // 粮油的编辑页
            } else {
              this._editModal(true, data.id)
            }
            break
          case '复制':
            this._copy(data.id, data.type)
            break
          case '删除':
            this._deleteById(data.id)
            break
          case '检测项目管理':
            this._itemManage(data.id)
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _record(id) {
      this.$refs.operationModal._openTask(id)
    },
    _itemManage(id) {
      this.$refs.itemManageModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectData':
          const selectIds = []
          for (let i = 0; i < data.length; i++) {
            selectIds.push(data[i].id)
          }
          this.selectIds = selectIds
          this.selectData = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _open(id) {
      console.log(id)
      this.formObj.entrustId = id
      this.showModal = true
      this._page()
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterSample.pageSampleDistributeHis(this.formObj)
      if (result) {
        this.getPage = result
        this.$refs.pageTable._hideLoading()
      }
    },
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this.$store.dispatch('FoodSample/deleteByIds', ids).then(() => {
            this._resultChange('删除成功!')
          })
        }
      })
    },
    _deleteById(id) {
      // 删除一条记录
      this._deleteByIds([id])
    },
    _deleteSelected() {
      // 批量删除
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this._deleteByIds(ids, '确定删除 ' + ids.length + ' 条记录？')
      }
    },
    _detailModal(id) {
      this.currentComponent = 'FoodSampleGovernDetail'
      this.$nextTick(function() {
        this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
          this.$refs.refModal._open(this.$store.state.FoodSample.governModel)
        })
      })
    },
    _editModal(edit, id) {
      this.currentComponent = 'FoodSampleGovernEdit'
      this.$nextTick(function() {
        if (edit) {
          this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
            this.$refs.refModal._open(
              this.$store.state.FoodSample.governModel,
              this.contractId
            )
          })
        } else {
          this.$refs.refModal._open('', this.contractId)
        }
      })
    },
    _editLY(id) {
      // 粮油的编辑
      this.currentComponent = 'FoodSampleGovernLYEdit'
      this.$nextTick(function() {
        this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
          this.$refs.refModal._open(
            this.$store.state.FoodSample.governModel,
            this.contractId
          )
        })
      })
    },
    _search() {
      this._page()
    },
    _searchParams() {
      const data = this.$serialize('search-sample-govern')
      return this.$extend(data, this.pageParams)
    },
    _resultChange(msg) {
      if (this.$store.state.FoodSample.success) {
        this._page()
        this.$Message.success(msg)
      }
    },
    _copy(sampleId, type) {
      this.$refs.refModal._open(sampleId, type)
    },
    // 复制样品
    _copySample(data) {
      if (data.type === 2) {
        // 粮油的编辑页
        this.currentComponent = 'FoodSampleGovernLYEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopySample(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      } else {
        this.currentComponent = 'FoodSampleGovernEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopySample(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      }
    },
    _copyAll(data) {
      if (data.type === 2) {
        // 粮油的编辑页
        this.currentComponent = 'FoodSampleGovernLYEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopyAll(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      } else {
        this.currentComponent = 'FoodSampleGovernEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopyAll(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      }
    },
    // 导入样品
    _importSample() {
      const data = {
        importUrl: '/food/v1/sample/government/import_' + this.contractId,
        downloadUrl: '/food/v1/excel/template/FoodSampleGovernment',
        title: '导入'
      }
      this.$refs.refModal._open(data)
    },
    // 导入检测项目
    _importItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择至少一项数据!')
        return false
      } else {
        this.$refs.importModal._open(this.selectIds)
      }
    },
    _importItemPackage() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds, 'batch-rel-package-item')
      }
    },
    _copyHisItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds)
      }
    },
    _itemDetail(id) {
      this.$refs.foodItem._open(id)
    },
    _operationRecord(id) {
      // 操作日志
      this.$refs.recordModal._open(id)
    }
  }
}
</script>
